# -*- coding: utf-8 -*-


from cStringIO import StringIO
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.CMFCore.utils import getToolByName
from Acquisition import aq_base

from Products.PloneOOoTransforms.config import PROJECTNAME, modules, modules_dir

from zLOG import LOG as log
from zLOG import WARNING

from Products.PortalTransforms.libtransforms.utils import MissingBinary


def install(self):                                       
    out = StringIO()

    # suppress word_to_html transformer
    engine = getToolByName(self, 'portal_transforms')
    if hasattr(aq_base(engine), 'word_to_html'):
        engine._delObject('word_to_html')
        print >>out,"Delete old transform word_to_html"

    # add transformers    
    for tname in modules:
        if hasattr(aq_base(engine), tname):
            engine._delObject(tname)
            print >>out,"Delete old transform %s" % tname            
            # and not engine.manage_delObjects([tname])
            # because in manage_delObjects,
            # engine would try to manipulate old uno transform via v.wl_isLocked()
            # [to see if it's lock by webdav]  (->exception in uno)
        print >>out,"Add transform %s" % tname
        engine.manage_addTransform(tname, 'Products.%s.%s.%s' % (PROJECTNAME, modules_dir, tname))


    # change left and right slots for the ploneooo tool
    obj = self.portal_oootransformtool
    left_slots=( 'here/portlet_prefs/macros/portlet', )
    right_slots=( )

    for key, value, data_type in [['left_slots',left_slots,'lines'],
                                  ['right_slots', right_slots, 'lines']]:
        if obj.hasProperty(key):
            obj._updateProperty(key, value)
        else:
            obj._setProperty(key, value, data_type)


    # add portlet_ploneoootransforms in right solots of plone
    portal = getToolByName(self,'portal_url').getPortalObject()
    if 'here/portlet_ploneoootransforms/macros/portlet' not in portal.right_slots:
        portal.right_slots = ['here/portlet_ploneoootransforms/macros/portlet'] + list(portal.right_slots)

            
        
    print >> out, "Successfully installed Custom Install of %s." % PROJECTNAME
    return out.getvalue()


def uninstall(self):                                       

    out = StringIO()

    engine = getToolByName(self, 'portal_transforms')
    
    # del transformers    
    for tname in modules:
        if hasattr(aq_base(engine), tname):
            engine._delObject(tname)
            print >>out,"Delete old transform %s" % tname  

    print >> out, "Successfully uninstalled Custom Install of %s." % PROJECTNAME
    return out.getvalue()
