#
# Initialise the product's module. There are three ways to inject custom code
# here:
#
#   - To set global configuration variables, create a file AppConfig.py. This
#       will be imported in config.py, which in turn is imported in each
#       generated class and in this file.
#   - To perform custom initialisation after types have been registered, use
#       the protected code section at the bottom of initialize().
#   - To register a customisation policy, create a file CustomizationPolicy.py
#       with a method register(context) to register the policy
#

from zLOG import LOG, INFO

LOG('PloneOOoTransforms',INFO, 'Installing Product')

try:
    import CustomizationPolicy
except ImportError:
    CustomizationPolicy=None

from Globals import package_home
from Products.CMFCore import utils as cmfutils
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore import DirectoryView
from Products.CMFPlone.utils import ToolInit
from Products.Archetypes.public import *
from Products.Archetypes import listTypes
from Products.Archetypes.utils import capitalize

import os, os.path

from Products.PloneOOoTransforms.config import *

DirectoryView.registerDirectory('skins', product_globals)
DirectoryView.registerDirectory('skins/PloneOOoTransforms',
                                    product_globals)

            

def initialize(context):

    # imports packages and types for registration
    import tools

    # patches for PortalTransforms
    import Patches
    
    # allow calling methods of Products.PortalTransforms.data.datastream
    # in python script (we want to call getSubObjects method).
    from AccessControl import allow_class, allow_type, allow_module
    from AccessControl import ModuleSecurityInfo
    from Products.PortalTransforms.data import datastream
    ModuleSecurityInfo('Products.PortalTransforms.data').declarePublic('datastream')  
    allow_class(datastream)

    # temp !!
    ModuleSecurityInfo('re').declarePublic('compile', 'findall',
                                           'match', 'search', 'split', 'sub', 'subn', 'error',
                                           'I', 'L', 'M', 'S', 'X')
    import re
    allow_type(type(re.compile('')))
    allow_type(type(re.match('x','x')))
    allow_module('re')
    
    #import pdb
    #allow_module('pdb')

    # problem security getMacro DataGridField 0.3
    from Products.DataGridField.Column import Column
    allow_class(Column)


    # initialize portal tools
    tools = [tools.OOoTransformTool.OOoTransformTool]
    ToolInit( PROJECTNAME +' Tools',
                tools = tools,
#                product_name = PROJECTNAME,
#                icon='tool.gif'
                ).initialize( context )

    # initialize portal content
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    cmfutils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = DEFAULT_ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

    # apply customization-policy, if theres any
    if CustomizationPolicy and hasattr(CustomizationPolicy, 'register'):
        CustomizationPolicy.register(context)
        print 'Customization policy for PloneOOoTransforms installed'

    ##code-section custom-init-bottom #fill in your manual code here
    ##/code-section custom-init-bottom

