#
# Product configuration. This contents of this module will be imported into
# __init__.py and every content type module.
#
# If you wish to perform custom configuration, you may put a file AppConfig.py
# in your product's root directory. This will be included in this file if
# found.
#

from Products.CMFCore.CMFCorePermissions import setDefaultRoles

PROJECTNAME = "PloneOOoTransforms"

# Check for Plone 2.1
try:
    from Products.CMFPlone.migrations import v2_1
except ImportError:
    HAS_PLONE21 = False
else:
    HAS_PLONE21 = True
    
# Permissions
DEFAULT_ADD_CONTENT_PERMISSION = "Add portal content"
setDefaultRoles(DEFAULT_ADD_CONTENT_PERMISSION, ('Manager', 'Owner'))

product_globals=globals()

# Dependencies of Products to be installed by quick-installer
# override in custom configuration
#DEPENDENCIES = []

# Dependend products - not quick-installed - used in testcase
# override in custom configuration
PRODUCT_DEPENDENCIES = []

# You can overwrite these two in an AppConfig.py:
# STYLESHEETS = [{'id': 'my_global_stylesheet.css'},
#                {'id': 'my_contenttype.css',
#                 'expression': 'python:object.getTypeInfo().getId() == "MyType"}]
# You can do the same with JAVASCRIPTS.
STYLESHEETS = [{'id': 'ploneoootransforms.css'}]
JAVASCRIPTS = [{'id': 'ploneoootransforms.js'}]

##code-section config-bottom #fill in your manual code here
DEPENDENCIES = ['DataGridField', 'PortalTransforms', 'MimetypesRegistry']

modules_dir = 'transforms'

modules = [
    'odt_to_pdf',     # via UNO, word, sxw, rtf to pdf
    'odt_to_msword',  # via UNO, word, sxw, odt, rtf to MS Word 97
    'odt_to_rtf',     # via UNO, word, sxw, odt, rtf to RTF
    'odt_to_sxw',     # via UNO, word, sxw, odt, rtf to SXW [OpenOffice]
    #'uno_to_odt',    # via UNO, word, sxw, odt, rtf to ODT [OpenDocumentTest] 
    'odt_to_html',    # via UNO, word, sxw, odt, rtf to HTML
    'impress_to_html',# via UNO, sxi, ppt,  to HTML
    'calc_to_html',   # via UNO, sxc, excel,  to HTML
    'calc_to_pdf',   # via UNO, sxc, excel,  to pdf            
    'html_to_odt',    # via UNO, html to odt
    'pdf_to_ps',      # via gs, pdf to ps
    'pdf_to_jpg',     # via gs, pdf to jpg
    'pdf_to_png',     # via gs, pdf to png
    'pdf_to_eps',     # via gs, pdf to eps
    'calc_to_xls',    # via UNO, sxc to xls
    'xls_to_calc',    # via UNO, xls to sxc
    'impress_to_ppt', # via UNO, sxi to ppt
    'ppt_to_impress', # via UNO, ppt to sxi
    'impress_to_swf', # via UNO, ppt, sxi to swf (flash)
    'impress_to_svg', # via UNO, ppt, sxi to svg
    'impress_to_pdf', # via UNO, ppt, sxi to pdf    
    ]


DEFAULT_SUPPORTEDCONV = ({'mt_in' : 'text/html', 'mt_out' : 'application/pdf'},
                         {'mt_in' : 'text/html', 'mt_out' : 'application/msword'},
                         {'mt_in' : 'text/html', 'mt_out' : 'application/vnd.sun.xml.writer'},
                         {'mt_in' : 'text/html', 'mt_out' : 'application/rtf'},
                         
                         {'mt_in' : 'application/msword', 'mt_out' : 'application/pdf'},
                         {'mt_in' : 'application/vnd.sun.xml.writer', 'mt_out' : 'application/pdf'},
                         {'mt_in' : 'application/vnd.ms-powerpoint', 'mt_out' : 'application/pdf'},
                         {'mt_in' : 'application/vnd.sun.xml.impress', 'mt_out' : 'application/pdf'},
                         {'mt_in' : 'application/vnd.ms-excel', 'mt_out' : 'application/pdf'},
                         {'mt_in' : 'application/vnd.sun.xml.calc', 'mt_out' : 'application/pdf'},
                         {'mt_in' : 'application/rtf', 'mt_out' : 'application/pdf'},
                         
                         {'mt_in' : 'application/msword', 'mt_out' : 'application/rtf'},

                         {'mt_in' : 'application/vnd.sun.xml.writer', 'mt_out' : 'application/msword'},

                         {'mt_in' : 'application/vnd.sun.xml.calc', 'mt_out' : 'application/vnd.ms-excel'},

                         {'mt_in' : 'application/vnd.sun.xml.impress', 'mt_out' : 'application/vnd.ms-powerpoint'},
                         
                         {'mt_in' : 'application/msword', 'mt_out' : 'text/html'},
                         {'mt_in' : 'application/vnd.sun.xml.writer', 'mt_out' : 'text/html'},
                         {'mt_in' : 'application/vnd.ms-powerpoint', 'mt_out' : 'text/html'},
                         {'mt_in' : 'application/vnd.sun.xml.impress', 'mt_out' : 'text/html'},
                         {'mt_in' : 'application/vnd.ms-excel', 'mt_out' : 'text/html'},
                         {'mt_in' : 'application/vnd.sun.xml.calc', 'mt_out' : 'text/html'},
                         {'mt_in' : 'application/rtf', 'mt_out' : 'text/html'},

                         {'mt_in' : 'application/vnd.ms-powerpoint', 'mt_out' : 'application/x-shockwave-flash'},
                         {'mt_in' : 'application/vnd.sun.xml.impress', 'mt_out' : 'application/x-shockwave-flash'},
                         
                         )


DEFAULT_OOOMODELS = ('fruitdepot.zexp', 'modele_pomme.zexp',  'zindep.zexp')



##/code-section config-bottom


# load custom configuration not managed by ArchGenXML
try:
    from Products.PloneOOoTransforms.AppConfig import *
except ImportError:
    pass

# End of config.py
