## Script (Python) "fileasPDF"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=File to XX
##

from Products.CMFCore.utils import getToolByName
import re

ptTool = getToolByName(context, 'portal_transforms')
mimetypes_registry = getToolByName(context, 'mimetypes_registry')

sp = traverse_subpath

filefield = sp[0]
f  = getattr(context, filefield)()
filename = f.filename
mt = f.getContentType()

output_ext = sp[1]
output_filename = '%s.%s' % (filename.split('.')[0], output_ext)
output = mimetypes_registry.lookupExtension(output_filename)

# if no subobject is requested, we don't make cache :
# maybe there is many many images for example !
object = context
if len(sp)==1:
    object=None

result = ptTool.convertTo(output,
                          str(f.data),
                          mimetype=mt,
                          object=object,
                          filename=filename,
                          context=context)
#except Exception:
#    return state.set(status='failure', portal_status_message='Sorry, unable to convert this file. Pb during conversion, maybe conversion is not possible or openoffice server is down ...')

if result:
    data = str(result)
    if output=='text/html':
        if len(sp) > 2:
            subobj_name = sp[2]
            subobjects = result.getSubObjects()
            result = re.match("^.+\.(?P<ext>.+)$", subobj_name)
            ext = result.group('ext')
            data = subobjects[subobj_name]
            if ext in ('png', 'jpg', 'gif'):
                output='image/png'

    if output=='text/html':
            pattern = re.compile("""(?P<tag><(?:a|img|A|IMG) [^>]*(?:src|href|SRC|HREF)=)(?P<url>['"][^'"]*?['"])(?P<end>.*?>)""",  re.MULTILINE| re.DOTALL)

            def replaceUrls(match):
                tag = match.group('tag')
                url = match.group('url')[1:-1]      #drop the quotes
                end = match.group('end')
                
                if not (url.startswith('http://') or url.startswith('#')):
                    url = '"%s/file_as/%s/%s/%s"' % (context.absolute_url(), filefield, output_ext, url)
                return tag + url + end

            data = pattern.sub(replaceUrls, data)

else:
    return state.set(status='failure', portal_status_message='Sorry, unable to convert this file. Conversion process exited normally but result is empty.')   

context.REQUEST.RESPONSE.setHeader("Content-Type",'%s;;charset=%s' % (output, 'utf-8'))
# context.REQUEST.RESPONSE.addHeader("Content-Disposition","filename=%s" % output_filename)
# if attachment, open the document in Acrobat Reader else open in browser
context.REQUEST.RESPONSE.setHeader('Content-Disposition','filename="%s"' % output_filename)
return data


