# File: OOoModel.py
# 
# Copyright (c) 2006 by Copyright (c) 2005 ZINDEP - http://www.zindep.com
# Generator: ArchGenXML Version 1.4.0-final 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *


from Products.CMFCore.utils import getToolByName
from Products.CMFCore.permissions import ModifyPortalContent

from Products.DataGridField.DataGridField import DataGridField
from Products.DataGridField.DataGridWidget import DataGridWidget
from Products.DataGridField.Column import Column
from Products.DataGridField.SelectColumn import SelectColumn

from Products.PloneOOoTransforms.config import *
from Products.PloneOOoTransforms import uno_utils




schema=Schema((

    LinesField('affected_types',
        widget=MultiSelectionWidget(
            label='Affected_types',
            label_msgid='PloneOOoTransforms_label_affected_types',
            description_msgid='PloneOOoTransforms_help_affected_types',
            i18n_domain='PloneOOoTransforms',
        ),
        schemata="Step 2: choose the affected types.",
        vocabulary='getTypes',
        multivalued="1"
    ),

    FileField('model_file',
        schemata="Step 3: upload odt file model.",
        widget=FileWidget(
            label='Model_file',
            label_msgid='PloneOOoTransforms_label_model_file',
            description_msgid='PloneOOoTransforms_help_model_file',
            i18n_domain='PloneOOoTransforms',
        ),
        storage=AttributeStorage()
    ),

    DataGridField('infodoc_mapfields',
        default=({'infodoc' : 'Title', 'field' : 'Title'}, {'infodoc' : 'Author', 'field' :'Creator'}, {'infodoc' : 'Subject', 'field' : 'Subject'}),
        widget=DataGridWidget(
            label='Infodoc_mapfields',
            label_msgid='PloneOOoTransforms_label_infodoc_mapfields',
            description_msgid='PloneOOoTransforms_help_infodoc_mapfields',
            i18n_domain='PloneOOoTransforms',
            columns= {'infodoc' : SelectColumn('InfoDoc OOo Fields', vocabulary='getInfodocVocabulary'), 'field': SelectColumn('Plone Objects Fields', vocabulary='getAtModelFields')},
        ),
        schemata="Step 4: map odt fields and content fields",
        columns=('infodoc', 'field',)
    ),

    DataGridField('user_mapfields',
        widget=DataGridWidget(
            label='User_mapfields',
            label_msgid='PloneOOoTransforms_label_user_mapfields',
            description_msgid='PloneOOoTransforms_help_user_mapfields',
            i18n_domain='PloneOOoTransforms',
            columns= {'user' : SelectColumn('User OOo Fields', vocabulary='getUserVocabulary'), 'field': SelectColumn('Plone Objects Fields', vocabulary='getAtModelFields')},            
        ),
        schemata="Step 4: map odt fields and content fields",
        columns=('user', 'field',)
    ),

    DataGridField('placeholder_mapfields',
        widget=DataGridWidget(
            label='Placeholder_mapfields',
            label_msgid='PloneOOoTransforms_label_placeholder_mapfields',
            description_msgid='PloneOOoTransforms_help_placeholder_mapfields',
            i18n_domain='PloneOOoTransforms',
            columns= {'placeholder' : SelectColumn('PlaceHolder OOo Fields', vocabulary='getPlaceholderVocabulary'), 'field': SelectColumn('Plone Objects Fields', vocabulary='getAtModelFields')},                        
        ),
        schemata="Step 4: map odt fields and content fields",
        columns=('placeholder', 'field',)
    ),

    BooleanField('insert_inflowdoc',
        widget=BooleanWidget(
            label='Insert_inflowdoc',
            label_msgid='PloneOOoTransforms_label_insert_inflowdoc',
            description_msgid='PloneOOoTransforms_help_insert_inflowdoc',
            i18n_domain='PloneOOoTransforms',
        )
    ),
    
    ImageField('preview',
               schemata="Step 5: change preview if you want",
               sizes= {'preview' : (400, 400),
                       'medium' : (200, 200),
                       'small' : (100, 100),
                       'icon'    :  (32, 32),
                      },
               )
    ),
              )


OOoModel_schema = BaseSchema + \
    schema



class OOoModel(BaseContent):
    """A template of output to use with OpenOffice"""
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'OOoModel'

    meta_type                  = 'OOoModel'
    portal_type                = 'OOoModel'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    content_icon               = 'ploneooo.png'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "OOoModel"
    typeDescMsgId              = 'description_edit_ooomodel'

    schema = OOoModel_schema


    # used for vocabularies
    infodocMapfields = []
    userMapfields = []
    placeholderMapfields = []



    #Methods

    security.declareProtected(ModifyPortalContent, 'setModel_file')
    def setModel_file(self, value, **kwargs):
        """set File and update vocabularies via uno"""

        ################################
        # original set method
        self.getField('model_file').set(self, value, **kwargs)
        

        ################################
        # update preview
        ptTool = getToolByName(self, 'portal_transforms')
        imagedata = ptTool.convertToData('image/jpeg',
                                     self.getModel_file().data,
                                     mimetype='application/msword',
                                     # object=self,
                                     filename=value.filename)
        self.getField('preview').set(self, imagedata, mimetype='image/jpeg', filename='preview.jpg') 
        


        ################################
        # update ooofields for vocabularies
        (doctmpdir, docfullname, modeldoc) = self.getUnoModel()

        # infodoc
        self.infodocMapfields = ['Author', 'Title', 'Subject']
        nb_fields = modeldoc.DocumentInfo.getUserFieldCount()
        for i in range(0, nb_fields):
            self.infodocMapfields.append(modeldoc.DocumentInfo.getUserFieldName(i))
        self.infodocMapfields.sort()

        # user
        self.userMapfields = list(modeldoc.TextFieldMasters.getElementNames())
        self.userMapfields.sort()

        # placeholder
        self.placeholderMapfields = []
        enum = modeldoc.getTextFields().createEnumeration()
        while enum.hasMoreElements():
            oofield = enum.nextElement()
            if oofield.supportsService("com.sun.star.text.TextField.JumpEdit"):
                self.placeholderMapfields.append(oofield.getPropertyValue("PlaceHolder"))
        self.placeholderMapfields.sort()


        try:
            modeldoc.close(True)
        except com.sun.star.util.CloseVetoException:
            pass

        uno_utils.cleanDir(doctmpdir)
    


    security.declarePublic('getTypes')
    def getTypes(self,):
        """
        
        """
        at_tool=getToolByName(self,'archetype_tool')
        at_types=at_tool.listRegisteredTypes()        
        at_list=[]
        for at in at_types:
            at_list.append(at['portal_type'])
        at_list.sort()
        return at_list


    security.declarePublic('getAtModelFields')
    def getAtModelFields(self,):
        """
        return fields of affected types of the model
        """
        fields = []
        at_tool=getToolByName(self,'archetype_tool')
        at_types=at_tool.listRegisteredTypes()
        for at in at_types:
            if at['portal_type'] in self.affected_types:
                # fields += at['schema'].fields()
                for field in at['schema'].fields():
                    if field.accessor not in fields:
                        fields.append(field.accessor)
        fields.sort()
        return DisplayList(zip(fields, fields))        



    security.declarePublic('getInfodocVocabulary')
    def getInfodocVocabulary(self):
        """   """
        return DisplayList(zip(self.infodocMapfields, self.infodocMapfields))        

    security.declarePublic('getUserVocabulary')
    def getUserVocabulary(self):
        """   """
        return DisplayList(zip(self.userMapfields, self.userMapfields))

    security.declarePublic('getPlaceholderVocabulary')
    def getPlaceholderVocabulary(self):
        """   """
        return DisplayList(zip(self.placeholderMapfields, self.placeholderMapfields))
    

    security.declarePublic('getUnoModel')
    def getUnoModel(self,):
        """
        return uno model (odt or sxw)
        """
        data = self.getModel_file().data
        return uno_utils.loadDocument(data, filename = 'model.odt')

        
    security.declarePublic('getPreviewTag')
    def getPreviewTag(self, **kwargs):
        """Generate image tag using the api of the ImageField
        """
        return self.getField('preview').tag(self, **kwargs)

        

registerType(OOoModel,PROJECTNAME)
# end of class OOoModel

##code-section module-footer #fill in your manual code here
##/code-section module-footer



