# File: OOoTransformTool.py
# 
# Copyright (c) 2006 by Copyright (c) 2005 ZINDEP - http://www.zindep.com
# Generator: ArchGenXML Version 1.4.0-final 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
import os, os.path

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *



from Products.PloneOOoTransforms.config import *

from Products.CMFCore.utils import UniqueObject
from Products.CMFCore.utils import getToolByName


from Products.DataGridField.DataGridField import DataGridField
from Products.DataGridField.DataGridWidget import DataGridWidget
from Products.DataGridField.Column import Column
from Products.DataGridField.SelectColumn import SelectColumn
    


schema=Schema((
    StringField('ooo_inputencode',
                default='utf-8', # for french people (OOo), use iso-8859-15 for example
                mode = 'rw',
        widget=StringWidget(
            label='Ooo_inputencode',
            label_msgid='PloneOOoTransforms_label_ooo_inputencode',
            description_msgid='PloneOOoTransforms_help_ooo_inputencode',
            i18n_domain='PloneOOoTransforms',
        )
    ),


    DataGridField('type_filefield',
        default=({'type' : 'File', 'field' : 'getFile'},),
        widget=DataGridWidget(
            label='Type_filefield',
            label_msgid='PloneOOoTransforms_label_type_filefield',
            description_msgid='PloneOOoTransforms_help_type_filefield',
            i18n_domain='PloneOOoTransforms',
            columns= {'type' : SelectColumn('Plone Product Type', vocabulary='getProductTypes'), 'field': SelectColumn('Plone Objects Fields', vocabulary='getAtFields')},
        ),
        columns=('type', 'field',)
    ),

    DataGridField('supported_conv',
        default = DEFAULT_SUPPORTEDCONV,
        widget=DataGridWidget(
            label='Supported_conv',
            label_msgid='PloneOOoTransforms_label_supported_conv',
            description_msgid='PloneOOoTransforms_help_supported_conv',
            i18n_domain='PloneOOoTransforms',
            columns= {'mt_in' : SelectColumn('MimeType Input', vocabulary='getAllMimeTypes'), 'mt_out': SelectColumn('MimeType Output', vocabulary='getAllMimeTypes')},
            ),
        # you can suppress mode='r' and add supported_conv if you want but there is no guarantee and edition will be very slow :S
        mode='r',          
        columns=('mt_in', 'mt_out',)
    ),

    

),
)


OOoTransformTool_schema = BaseFolderSchema + \
    schema


class OOoTransformTool(UniqueObject,BaseFolder):
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseFolder,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'OOoTransformTool'

    meta_type                  = 'OOoTransformTool'
    portal_type                = 'OOoTransformTool'
    allowed_content_types      = ['OOoModel']
    filter_content_types       = 1
    global_allow               = 0
    allow_discussion           = 0
    content_icon               = 'ploneooo.png'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "OOoTransformTool"
    typeDescMsgId              = 'description_edit_oootransformtool'
    toolicon                   = 'ploneooo.png'

    schema = OOoTransformTool_schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseFolder.__init__(self,'portal_oootransformtool')
        

    def manage_afterAdd(self,item,container):
        """
        after adding the tool, we import zexp_models by default ...
        """
        for ooomodel_fname in DEFAULT_OOOMODELS:
            fpath = os.path.join(os.environ.get('INSTANCE_HOME', ''), 'Products', 'PloneOOoTransforms', 'zexp_models', ooomodel_fname)
            item._importObjectFromFile(fpath)


    


    #Methods

    security.declarePublic('getOOoModelsFor')
    def getOOoModelsFor(self, portal_type):
        """
        
        """
        models = []
        for obj in self.objectValues():
            if obj.portal_type == 'OOoModel':
                if portal_type in obj.getAffected_types():
                    models.append(obj)
        return models


    security.declarePublic('getOoomodel_affectedtypes')
    def getOoomodel_affectedtypes(self,):
        """
        """
        types = []
        for obj in self.objectValues():
            if obj.portal_type == 'OOoModel':
                types = types + list(obj.getAffected_types())
        return types


    security.declarePublic('getAll_affectedtypes')
    def getAll_affectedtypes(self,):
        """
        """
        types = self.getOoomodel_affectedtypes()

        types_fromfile = self.getType_filefield()
        for t in types_fromfile:
            types.append(t['type'])
        
        # unique values
        d = {}
        for t in types:
            d[t]=1
        return d.keys()


    security.declarePublic('isSupportedForconv')
    def isSupportedForconv(self, obj):
        """
        """
        ptype = getattr(obj, 'portal_type', '')
        if ptype in self.getAll_affectedtypes():
            return True
        else:
            return False
        

    security.declarePublic('getProductTypes')
    def getProductTypes(self,):
        """
        """
        at_tool=getToolByName(self,'archetype_tool')
        at_types=at_tool.listRegisteredTypes()        
        at_list=[]
        for at in at_types:
            at_list.append(at['portal_type'])
        at_list.sort()
        return DisplayList(zip(at_list, at_list))
        

    security.declarePublic('getAtFields')
    def getAtFields(self,):
        """
        """
        fields = []
        at_tool=getToolByName(self,'archetype_tool')
        at_types=at_tool.listRegisteredTypes()
        for at in at_types:
                for field in at['schema'].fields():
                    if field.accessor not in fields and field.accessor != None:
                        fields.append(field.accessor)
        fields.sort()
        #import pdb; pdb.set_trace()
        return DisplayList(zip(fields, fields))



    security.declarePublic('getAllMimeTypes')
    def getAllMimeTypes(self,):
        """
        """
        mimetypes_registry = getToolByName(self, 'mimetypes_registry')
        mimetypes = mimetypes_registry.list_mimetypes()
        return DisplayList(zip(mimetypes, mimetypes))
        

    security.declarePublic('getMimetypesOutputFor')
    def getMimetypesOutputFor(self, input):
        """
        """
        mimetypes = []
        convs = self.getSupported_conv()
        for conv in convs:
            if conv['mt_in'] == input:
                mimetypes.append(conv['mt_out'])
        return mimetypes



    def getFileFieldsFor(self, obj):
        """
        """
        fields = []
        type_filefield = self.getType_filefield()
        for tf in type_filefield:
            if tf['type'] == obj.portal_type:
                fields.append(tf['field'])
        return fields
                                 

registerType(OOoTransformTool,PROJECTNAME)
# end of class OOoTransformTool

##code-section module-footer #fill in your manual code here
##/code-section module-footer



