# -*- coding: utf-8 -*-

"""
PloneOOoTransforms

(C) 2005, 2006, ZINDEP and Contributors
http://www.zindep.com

Contact: plone@zindep.com

License: see LICENSE.txt

"""

from Products.PortalTransforms.interfaces import itransform
from Products.PortalTransforms.utils import log
from Products.CMFCore.utils import getToolByName

from Products.PloneOOoTransforms import uno_utils

from htm_to_odt import document


import os.path


class html_to_odt:
    __implements__ = itransform

    __name__ = "html_to_odt"
    inputs   = ('text/html',)
    output  = 'application/vnd.oasis.opendocument.text'
    output_encoding = 'utf-8'

    tranform_engine = document.__module__

    def name(self):
        return self.__name__

    def convert(self, data, cache, **kwargs):
        """ XXX docstring """

        orig_file = kwargs.get('filename','unknown.html')
        
        self.context = kwargs.get('context')
        self.images = []

        # try to decode/encode data
        try:
            prop = getToolByName(self.context, 'portal_properties')
            oootool = getToolByName(self.context, 'portal_oootransformtool')
            decoding = prop.site_properties.getProperty('default_charset', 'utf-8')
            encoding = oootool.getOoo_inputencode()
            data = data.decode(decoding).encode(encoding)
        except:
            pass


        data = uno_utils.fixUrlsImages(self.context, self.images, data)

        doc = document(orig_file, data)
        
        #images copy in tmp
        # log('images : %s' % data,
        #     severity=100)

        for img in self.images:
            pathimg = os.path.join(doc.tmpdir, img.getId())
            filedest = open(pathimg , "wb")
            filedest.write(str(img.getImage().data))    
            
        doc.convert(**kwargs)

        out = doc.read()

        # path, images = doc.subObjects(doc.tmpdir)
        # objects = {}
        # if images:
        #     doc.fixImages(path, images, objects)

        cache.setData(out)
        # cache.setSubObjects(objects)

        doc.cleanDir(doc.tmpdir)

        return cache



def register():
    return html_to_odt()
